Subject: Re: [PATCH] CUBIC v2.3 with new improved slow start

From: Stephen Hemminger <[email-masked]>
Date: Wed, 29 Oct 2008 16:40:45 -0700

On Wed, 29 Oct 2008 19:14:03 -0400
"Injong Rhee" <[email-masked]> wrote:

> >
> > This looks like a good optimization, it obviously needs more testing
> > because Linux always seems to find new broken hardware.  The areas
> > that need to be tested should include:
> >  * MacOs has a broken version of delayed ack that might cause
> >    HyStart to radically underestimate.
> 
> We tested with FreeBSD. I presume that it covers MacOS. We will look into 
> that.

No Darwin added some stupid code that holds off acks for up to 2 seconds.

> >  * Applications that dribble out packets might get better (or
> >    worse) performance.  This include dumb web servers.
> 
> Not really. It does not affect those flows that do not use their full 
> capacity of the network. HyStart kicks in only when the flow are using more 
> than avail bw during slow start. If the applications do not pump data in, it 
> would still be in slow start -- while in slow start, HyStart works like the 
> traditional slow start (double cwnd per rtt).
> 
> >  * Does this increase or reduce latency when using TCP for
> >    applications which never fill the congestion window? (games, financial, 
> > etc).
> >
> 
> For the same reasons as above, No, HyStart does not engage in this 
> situation. 
> 

Ok